# TODO: __pycache__ for python3-PyQt4-uic
#
# Conditional build:
%bcond_without	python2	# CPython 2.x modules
%bcond_without	python3	# CPython 3.x modules

%define		module	PyQt4
# minimal required sip version
%define		sip_ver	2:4.19.1
# last qt version covered by these bindings (minimal required is currently 4.1.0)
%define		qt_ver	4.8.7

Summary:	Python 2 bindings for the Qt4 toolkit
Summary(pl.UTF-8):	Wiązania Pythona 2 do toolkitu Qt4
Name:		python-%{module}
Version:	4.12.1
Release:	3
License:	GPL v3
Group:		Libraries/Python
Source0:	http://downloads.sourceforge.net/pyqt/PyQt4_gpl_x11-%{version}.tar.gz
# Source0-md5:	0112e15858cd7d318a09e7366922f874
Patch0:		%{name}-dbuspath.patch
Patch1:		%{name}-64bit.patch
URL:		http://www.riverbankcomputing.com/software/pyqt/
# most of BR comes from configure.py
BuildRequires:	QtAssistant-compat-devel >= 4.6.3
BuildRequires:	QtCore-devel >= %{qt_ver}
BuildRequires:	QtDBus-devel >= %{qt_ver}
BuildRequires:	QtDeclarative-devel >= %{qt_ver}
BuildRequires:	QtDesigner-devel >= %{qt_ver}
BuildRequires:	QtGui-devel >= %{qt_ver}
BuildRequires:	QtHelp-devel >= %{qt_ver}
BuildRequires:	QtMultimedia-devel >= %{qt_ver}
BuildRequires:	QtNetwork-devel >= %{qt_ver}
BuildRequires:	QtOpenGL-devel >= %{qt_ver}
BuildRequires:	QtScript-devel >= %{qt_ver}
BuildRequires:	QtScriptTools-devel >= %{qt_ver}
BuildRequires:	QtSql-devel >= %{qt_ver}
BuildRequires:	QtSvg-devel >= %{qt_ver}
BuildRequires:	QtTest-devel >= %{qt_ver}
BuildRequires:	QtWebKit-devel >= %{qt_ver}
BuildRequires:	QtXml-devel >= %{qt_ver}
BuildRequires:	QtXmlPatterns-devel >= %{qt_ver}
BuildRequires:	phonon-devel
BuildRequires:	pkgconfig
BuildRequires:	python-dbus-devel >= 0.80
%if %{with python2}
BuildRequires:	python-dbus >= 0.80
BuildRequires:	python-sip-devel >= %{sip_ver}
%endif
%if %{with python3}
BuildRequires:	python3-dbus >= 0.80
BuildRequires:	python3-sip-devel >= %{sip_ver}
%endif
BuildRequires:	qt4-build >= 4.3.3-3
BuildRequires:	qt4-qmake >= 4.3.3-3
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.219
Requires:	python-libs
Requires:	python-dbus >= 0.80
Requires:	python-sip >= %{sip_ver}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sipfilesdir	%{_datadir}/sip

%description
PyQt4 is a set of Python bindings for the Qt4 toolkit. The bindings
are implemented as a set of Python modules: QtCore, QtDeclarative,
QtDesigner, QtGui, QtHelp, QtMultimedia, QtNetwork, QtOpenGL,
QtScript, QtScriptTools, QtSql, QtSvg, QtTest, QtWebKit, QtXml,
QtXmlPatterns and phonon.

This package contains Python 2 bindings.

%description -l pl.UTF-8
PyQt4 to zbiór wiązań Qt4 dla Pythona. Dowiązania zostały
zaimplementowane jako moduły Pythona: QtCore, QtDeclarative,
QtDesigner, QtGui, QtHelp, QtMultimedia, QtNetwork, QtOpenGL,
QtScript, QtScriptTools, QtSql, QtSvg, QtTest, QtWebKit, QtXml,
QtXmlPatterns oraz phonon.

Ten pakiet zawiera wiązania Pythona 2.

%package uic
Summary:	pyuic4 development tool for Python 2
Summary(pl.UTF-8):	Narzędzie programistyczne pyuic4 dla Pythona 2
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}

%description uic
pyuic4 development tool for Python 2.

%description uic -l pl.UTF-8
Narzędzie programistyczne pyuic4 dla Pythona 2.

%package -n python3-PyQt4
Summary:	Python 2 bindings for the Qt4 toolkit
Summary(pl.UTF-8):	Wiązania Pythona 2 do toolkitu Qt4
Group:		Libraries/Python
Requires:	python3-libs
Requires:	python3-dbus >= 0.80
Requires:	python3-sip >= %{sip_ver}

%description -n python3-PyQt4
PyQt4 is a set of Python bindings for the Qt4 toolkit. The bindings
are implemented as a set of Python modules: QtCore, QtDeclarative,
QtDesigner, QtGui, QtHelp, QtMultimedia, QtNetwork, QtOpenGL,
QtScript, QtScriptTools, QtSql, QtSvg, QtTest, QtWebKit, QtXml,
QtXmlPatterns and phonon.

This package contains Python 3 bindings.

%description -n python3-PyQt4 -l pl.UTF-8
PyQt4 to zbiór wiązań Qt4 dla Pythona. Dowiązania zostały
zaimplementowane jako moduły Pythona: QtCore, QtDeclarative,
QtDesigner, QtGui, QtHelp, QtMultimedia, QtNetwork, QtOpenGL,
QtScript, QtScriptTools, QtSql, QtSvg, QtTest, QtWebKit, QtXml,
QtXmlPatterns oraz phonon.

Ten pakiet zawiera wiązania Pythona 3.

%package -n python3-PyQt4-uic
Summary:	pyuic4 development tool for Python 3
Summary(pl.UTF-8):	Narzędzie programistyczne pyuic4 dla Pythona 3
Group:		Development/Tools
Requires:	python3-PyQt4 = %{version}-%{release}

%description -n python3-PyQt4-uic
pyuic4 development tool for Python 3.

%description -n python3-PyQt4-uic -l pl.UTF-8
Narzędzie programistyczne pyuic4 dla Pythona 3.

%package devel-tools
Summary:	PyQt4 development tools
Summary(pl.UTF-8):	Narzędzia programistyczne PyQt4
Group:		Development/Tools
Requires:	QtCore >= %{qt_ver}
Requires:	QtXml >= %{qt_ver}

%description devel-tools
PyQt4 development tools: pylupdate4, pyrcc4.

Note: this package doesn't depend on Python version.

%description devel-tools -l pl.UTF-8
Narzędzia programistyczne PyQt4: pylupdate4, pyrcc4.

Uwaga: ten pakiet nie jest zależny od wersji Pythona.

%package examples
Summary:	Examples for PyQt4
Summary(pl.UTF-8):	Przykłady do PyQt4
Group:		Libraries/Python
Requires:	%{name} = %{version}-%{release}

%description examples
Examples code demonstrating how to use the Python bindings for Qt4.

%description examples -l pl.UTF-8
Przykładowy kod demonstrujący jak używać PyQt4.

%package -n sip-PyQt4
Summary:	SIP files needed to build other bindings based on Qt4
Summary(pl.UTF-8):	Pliki SIP potrzebne do budowania innych wiązań opartych na Qt4
Group:		Development/Languages/Python
Requires:	sip >= %{sip_ver}
Obsoletes:	python-PyQt4-devel < 4.11.3-2

%description -n sip-PyQt4
SIP files needed to build other bindings for C++ classes that inherit
from any of the Qt4 classes (e.g. KDE or your own).

%description -n sip-PyQt4 -l pl.UTF-8
Pliki SIP potrzebne do budowania innych wiązań do klas C++
dziedziczących z dowolnej klasy Qt4 (np. KDE lub własnych).

%package -n QtDesigner-plugin-pyqt4
Summary:	Qt Designer plugin for Python plugins with widgets
Summary(pl.UTF-8):	Wtyczka Qt Designera dla wtyczek Pythona zawierających widgety
# can build only for one python version
%if %{with python2}
Requires:	%{name} = %{version}-%{release}
%else
Requires:	python3-PyQt4 = %{version}-%{release}
%endif

%description -n QtDesigner-plugin-pyqt4
This is the Qt Designer plugin that collects all the Python plugins it
can find as a widget collection to Designer.

%description -n QtDesigner-plugin-pyqt4 -l pl.UTF-8
Ten pakiet zawiera wtyczkę Qt Designera zbierającą wszystkie wtyczki
Pythona, które jest w stanie znaleźć, jako zestaw widgetów dla
Designera.

%package -n qscintilla2-%{module}-api
Summary:	PyQt4 API file for QScintilla
Summary(pl.UTF-8):	Plik API PyQt4 dla QScintilli
Group:		Libraries/Python
Requires:	qscintilla2-qt4 >= 2.8.4

%description -n qscintilla2-%{module}-api
PyQt4 API file can be used by the QScintilla editor component to
enable the use of auto-completion and call tips when editing PyQt4
code.

%description -n qscintilla2-%{module}-api -l pl.UTF-8
Plik API PyQt4 może być używany przez komponent edytora QScintilla aby
umożliwić automatyczne dopełnianie i podpowiedzi przy modyfikowaniu
kodu wykorzystującego PyQt4.

%prep
%setup -q -n PyQt4_gpl_x11-%{version}
# small hack to build for shared libs - symbol QT_SHARED not defined anymore?
%{__sed} -i 's/qt_shared = lines\[.*\]/qt_shared = "y"/' configure.py
%{__sed} -i 's/resp = sys.stdin.readline.*/resp = "yes"/' configure.py
%patch0 -p1
%patch1 -p1

%build
%if %{with python2}
install -d build-py2
cd build-py2
%{__python} ../configure.py \
	--confirm-license \
	-c -j 3 \
	-a \
	-b %{_bindir} \
	-d %{py_sitedir} \
	-q "%{_bindir}/qmake-qt4" \
	-v %{_sipfilesdir}/%{module} \
	--dbus-path="%{py_sitedir}/dbus/mainloop" \
	LIBDIR_QT="%{_libdir}" \
	CC="%{__cc}" \
	CXX="%{__cxx}"

%{__make}
cd ..
%endif

%if %{with python3}
install -d build-py3
cd build-py3
%{__python3} ../configure.py \
	--confirm-license \
	-c -j 3 \
	-a \
	-b %{_bindir} \
	-d %{py3_sitedir} \
	-q "%{_bindir}/qmake-qt4" \
	-v %{_sipfilesdir}/%{module} \
	--dbus-path="%{py3_sitedir}/dbus/mainloop" \
	LIBDIR_QT="%{_libdir}" \
	CC="%{__cc}" \
	CXX="%{__cxx}"

%{__make}
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%if %{with python3}
%{__make} -C build-py3 install \
	DESTDIR=$RPM_BUILD_ROOT \
	INSTALL_ROOT=$RPM_BUILD_ROOT

%{__mv} $RPM_BUILD_ROOT%{_bindir}/pyuic4{,-3}

%py3_comp $RPM_BUILD_ROOT%{py3_sitedir}
%py3_ocomp $RPM_BUILD_ROOT%{py3_sitedir}
%endif

%if %{with python2}
%{__make} -C build-py2 install \
	DESTDIR=$RPM_BUILD_ROOT \
	INSTALL_ROOT=$RPM_BUILD_ROOT

%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}

# don't use py_postclean, leave *.py in %{py_sitedir}/PyQt4/uic/widget-plugins
%{__rm} $RPM_BUILD_ROOT%{py_sitedir}/PyQt4/*.py
%{__rm} $RPM_BUILD_ROOT%{py_sitedir}/PyQt4/uic/*.py
%{__rm} $RPM_BUILD_ROOT%{py_sitedir}/PyQt4/uic/Compiler/*.py
%{__rm} $RPM_BUILD_ROOT%{py_sitedir}/PyQt4/uic/Loader/*.py
%{__rm} $RPM_BUILD_ROOT%{py_sitedir}/PyQt4/uic/port_v2/*.py
%{__rm} $RPM_BUILD_ROOT%{py_sitedir}/PyQt4/uic/port_v3/*.py

%{__sed} -i 's,pyuic.py,pyuic.pyc,' $RPM_BUILD_ROOT%{_bindir}/pyuic4
%endif

cp -R examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc NEWS README THANKS
%dir %{py_sitedir}/PyQt4
%attr(755,root,root) %{py_sitedir}/PyQt4/Qt.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtAssistant.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtCore.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtDBus.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtDeclarative.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtDesigner.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtGui.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtHelp.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtMultimedia.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtNetwork.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtOpenGL.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtScript.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtScriptTools.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtSql.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtSvg.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtTest.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtWebKit.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtXml.so
%attr(755,root,root) %{py_sitedir}/PyQt4/QtXmlPatterns.so
%attr(755,root,root) %{py_sitedir}/PyQt4/phonon.so
%{py_sitedir}/PyQt4/__init__.py[co]
%{py_sitedir}/PyQt4/pyqtconfig.py[co]
%attr(755,root,root) %{py_sitedir}/dbus/mainloop/qt.so

%files uic
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pyuic4
%{py_sitedir}/PyQt4/uic
%endif

%if %{with python3}
%files -n python3-PyQt4
%defattr(644,root,root,755)
%doc NEWS README THANKS
%dir %{py3_sitedir}/PyQt4
%attr(755,root,root) %{py3_sitedir}/PyQt4/Qt.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtAssistant.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtCore.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtDBus.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtDeclarative.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtDesigner.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtGui.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtHelp.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtMultimedia.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtNetwork.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtOpenGL.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtScript.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtScriptTools.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtSql.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtSvg.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtTest.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtWebKit.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtXml.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/QtXmlPatterns.so
%attr(755,root,root) %{py3_sitedir}/PyQt4/phonon.so
%{py3_sitedir}/PyQt4/__pycache__
%{py3_sitedir}/PyQt4/__init__.py
%{py3_sitedir}/PyQt4/pyqtconfig.py
%attr(755,root,root) %{py3_sitedir}/dbus/mainloop/qt.so

%files -n python3-PyQt4-uic
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pyuic4-3
%{py3_sitedir}/PyQt4/uic
%endif

%files devel-tools
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pylupdate4
%attr(755,root,root) %{_bindir}/pyrcc4

%files examples
%defattr(644,root,root,755)
%{_examplesdir}/%{name}-%{version}

%files -n sip-PyQt4
%defattr(644,root,root,755)
%{_sipfilesdir}/PyQt4

%files -n QtDesigner-plugin-pyqt4
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/qt4/plugins/designer/libpyqt4.so

%files -n qscintilla2-%{module}-api
%defattr(644,root,root,755)
%{_datadir}/qt4/qsci/api/python/PyQt4.api
%changelog
* Sun Jul 01 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-PyQt4.git;a=log;h=auto/th/python-PyQt4-4.12.1-3

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> c4263b8
- python 3.7 rebuild
- release 3 (by relup.sh)

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> d279319
- python 3.7 rebuild
- release 2 (by relup.sh)

* Tue Jul 04 2017 Jakub Bogusz <qboosh@pld-linux.org> 3785869
- updated to 4.12.1

* Sat Dec 31 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> b52fc56
- up to 4.12

* Wed Dec 28 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 95ac749
- python 3.6
- release 5 (by relup.sh)

* Sat Nov 19 2016 Jacek Konieczny <jajcus@jajcus.net> 5b67931
- Fix pyuic4-3

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 36ce042
- release 3 (by relup.sh)

* Mon Nov 09 2015 Jakub Bogusz <qboosh@pld-linux.org> 1105d20
- License is just GPL v3 now

* Mon Sep 14 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> aa521e5
- python3.5 rebuild
- release 2 (by relup.sh)

* Thu Aug 27 2015 Mateusz Korniak <matkor@pld-linux.org> 9338006
- updated to 4.11.4

* Wed Jun 10 2015 Elan Ruusamäe <glen@delfi.ee> 9ec8953
- x32 rebuild
- release 4 (by relup.sh)

* Thu Mar 05 2015 Jan Rękorajski <baggins@pld-linux.org> 6170514
- release 3 (by relup.sh)

* Tue Nov 18 2014 Jakub Bogusz <qboosh@pld-linux.org> 314c0a4
- preparing for multi-qt multi-python qscintilla; renamed python-PyQt4-devel to sip-PyQt4
- release 2

* Fri Nov 14 2014 Jakub Bogusz <qboosh@pld-linux.org> a14db2c
- updated to 4.11.3

* Sat Nov 01 2014 Jakub Bogusz <qboosh@pld-linux.org> d58ddff
- python* bconds fix

* Fri Oct 31 2014 Jakub Bogusz <qboosh@pld-linux.org> b7e0daa
- build for both python 2 and 3
- separated -uic and QtDesigner-plugin-pyqt4 to make dual packages possible

* Wed Oct 29 2014 Jakub Bogusz <qboosh@pld-linux.org> 3636281
- updated dependencies

* Sat Oct 18 2014 Jan Rękorajski <baggins@pld-linux.org> ac8c330
- up to 4.11.2

* Fri Dec 27 2013 Jakub Bogusz <qboosh@pld-linux.org> 838f959
- updated to 4.10.3

* Tue Dec 11 2012 Jakub Bogusz <qboosh@pld-linux.org> 6f3bf9f
- updated sip version

